﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Services.Hive;

namespace HeuristicLab.Clients.Hive.Tests {
  public class MockServiceLocator : IServiceLocator {
    private string username;
    public string Username {
      get { return username; }
      set { username = value; }
    }

    private string password;
    public string Password {
      get { return password; }
      set { password = value; }
    }

    public HeuristicLab.Services.Hive.ServiceContracts.IHiveService GetService() {
      HiveService service = new HeuristicLab.Services.Hive.HiveService();
      return service;
    }

    public void CallHiveService(Action<HeuristicLab.Services.Hive.ServiceContracts.IHiveService> call) {
      call(GetService());
    }

    public T CallHiveService<T>(Func<HeuristicLab.Services.Hive.ServiceContracts.IHiveService, T> call) {
      return call(GetService());
    }

    #region IServiceLocator Members

    public void CallHiveService(Action<IHiveService> call) {
      // how to do this?
    }

    public T CallHiveService<T>(Func<IHiveService, T> call) {
      // how to do this?
      throw new NotImplementedException();
    }

    #endregion
  }
}
